/**
* cookie Ext Core extensions
* Ext.ux.Cookie
* version 1.0.1
*
* last updated 2010/10/24
* copyright info@plasmasphere.net http://www.plasmasphere.net/
*/

Ext.ns('Ext.ux');
Ext.ux.Cookie = Ext.extend(Ext.util.Observable, {
	expires: 60*60*24*7*1000, // 1week
	path: '/',

	constructor: function(config){
		config = config || {};
		Ext.apply(this, config);
		this.addEvents(
			'change'
		);

		Ext.ux.Cookie.superclass.constructor.call(this, config);

		this.init();
	},

	init: function() {
		this.parseCookie();
		var dat = new Date();
		this.expires = 'expires='+new Date(dat.setTime(dat.getTime()+this.expires)).toGMTString()+';';
	},

	set: function(cn, val) {
		document.cookie = cn+'='+escape(val)+';path='+this.path+';expires='+this.expires;
		this.fireEvent('change', cn, val);
	},

	get: function(cn, df) {
		if(this.cookie) {
			for(var i in this.cookie){
				if(String(i).replace(/^\s+|\s+$/g, '')==cn) {
					return unescape(this.cookie[i]);
				}
			}
		}
		return df;
	},

	clear: function(cn) {
		var dat = new Date();
		document.cookie = cn+'=del;expires='+new Date(dat.setHours(dat.getHours()-1)).toGMTString();
	},

	parseCookie: function() {
		this.cookie = {};
		var cookie = document.cookie;
		cookie = cookie.split(';');
		if(cookie&&cookie.length) {
			for(var i in cookie){
				if(typeof cookie[i] == "string") {
					var val = cookie[i].split('=');
					this.cookie[val[0]] = val[1];
				}
			}
		}
	}
});
